import * as React from "react";
import { IState } from "./IState";
export interface IDataGridStateContext {
    state: IState;
    dispatch: React.Dispatch<IAction>;
}
export declare const DataGridState: React.Context<IDataGridStateContext | undefined>;
declare type ReducerActionType = "set-total" | "set-page" | "set-rowsperpage" | "set-orderBy" | "set-filter" | "reload";
export interface IAction {
    type: ReducerActionType;
    payload: any;
}
export declare function reducer(s: any, action: {
    type: ReducerActionType;
    payload: any;
}): any;
interface IDataGripStateProviderProps {
    children: React.ReactNode;
    initialOrderBy?: string;
    initialSort?: "asc" | "desc";
}
export declare function DataGridStateProvider(props: IDataGripStateProviderProps): JSX.Element;
export {};
