"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
exports.DataGridState = React.createContext(undefined);
function reducer(s, action) {
    switch (action.type) {
        case "set-total":
            return __assign({}, s, { total: action.payload });
        case "set-page":
            return __assign({}, s, { page: action.payload });
        case "set-rowsperpage":
            return __assign({}, s, { rowsPerPage: action.payload });
        case "set-orderBy":
            return __assign({}, s, action.payload);
        case "set-filter":
            return __assign({}, s, { filter: __assign({}, s.filter, action.payload) });
        case "reload":
            return __assign({}, s, { reloadDummy: !s.reloadDummy });
        default:
            throw new Error();
    }
}
exports.reducer = reducer;
function DataGridStateProvider(props) {
    var _a = React.useReducer(reducer, {
        rowsPerPage: 10,
        page: 0,
        total: 0,
        orderBy: props.initialOrderBy,
        sort: "asc",
        filter: {}
    }), state = _a[0], dispatch = _a[1];
    return (React.createElement(exports.DataGridState.Provider, { value: { state: state, dispatch: dispatch } }, props.children));
}
exports.DataGridStateProvider = DataGridStateProvider;
